package ExamplesFromLecture;

import java.io.File;
import java.io.FileNotFoundException;
import java.util.Iterator;
import java.util.Scanner;
import java.util.Vector;

public class L13 {

	/**
	 * @param args
	 * @throws FileNotFoundException
	 */
	public static void main(String[] args) throws FileNotFoundException {
		// the purpose of this example is to show that Scanner
		// is an Iterator
		File fileObject = new File("tmp");
		Scanner input = new Scanner(fileObject);
		// OR you can do it all in one shot
		Scanner input2 = new Scanner(new File("tmp"));
		// they both work because they are using the same constructor
		// Scanner(File);

		while (input.hasNext()) {
			System.out.println(input.next());
		}
		// the above statement demonstrate that Scanner provides services that
		// allow us to iterate over some elements. The elements are String
		// objects

		// the angle bracket notation means the type of the declaration is
		// a "GENERIC" type (a generic type is a type for which you need to
		// provide a type as a parameter

		// I want to print "***" if an element from the
		// iterator matches "hello"
		Iterator<String> myIterator;
		myIterator = new Scanner(new File("tmp"));
		final String TARGET = "hello";
		while (myIterator.hasNext()) {
			String currentElement = myIterator.next();
			// boolean isMatch = currentElement.equals(TARGET);
			boolean isMatch = currentElement.contains(TARGET);
			if (isMatch) {
				System.out.println("***");
			}
			System.out.println(currentElement);
		}

		// once you go through the Iterator, that's it, no more - see how the
		// following line causes an exception to be thrown
		String anotherElement = myIterator.next();
		System.out.println(anotherElement);

		// This is how we declare a vector
		// a vector is a certain type of list

		// here we declare the variable to be of type Vector. Since vector is
		// a generic type, we need to say a vector of what, or in other words
		// what is the type of the elements of the vector
		Vector<String> myVector;
		// the goal of this section is to take the iterator and populate
		// our data structure with the elements of the iterator

		// this constructs an empty vector
		// vectors allow duplicates
		// vectors can grow to an arbitrarily large size
		// vectors provide an "add" operation.
		myVector = new Vector<String>();
		while (input2.hasNext()) {
			String theElement = input2.nextLine();
			myVector.add(theElement);
		}
		Integer someValue = new Integer("89");
		// we cannot add an integer to our vector because it is not of type
		// String

		// The generic types are an example of the principle
		// "risk mitigation by early exposure"
		// myVector.add(someValue);

	}
}
